var ws= null;

var onLoadFunction= function() {
	new Sortable(document.getElementById('demo'), {
	    animation: 150,
	    ghostClass: 'blue-background-class',
	    onEnd: function (evt) {
			var itemEl= evt.item;  // dragged HTMLElement
			
			var offset= -0.1;
			if (evt.newIndex > evt.oldIndex) {
				offset= 0.1;
			}
			
			ws.send(JSON.stringify({
		        action: 'moveToDoItem',
		        itemId: itemEl.dataset.id,
		        newSortOrder: (evt.newIndex+offset+1)
	        }));
		}
	});
	
	connectWebSocket();
};

var connectWebSocket= function() {
	ws= new WebSocket('ws://127.0.0.1:8081/websocket/todolist','json'); // Server address / SPECIFICATION
	ws.onmessage= function(msg) { updateToDoList(msg); };
};

var updateToDoList= function(msg) { // Update chat-panel and list of connected users
    var data= JSON.parse(msg.data);
    
    if (data.event == 'updateList') {
    	var listItemsHTML= '';
    	
	    for (var i= 0; i< data.toDoList.length; i++) {
		    listItemsHTML+= '<div class="list-group-item" data-id="'+data.toDoList[i].id+'">'+data.toDoList[i].title+'</div>';
	    }
	    
		document.getElementById('demo').innerHTML= listItemsHTML;
    }
    
};

var addToItem= function() {
	var titleToAdd= prompt('Add To Do Item','');
    if (titleToAdd) {
	    ws.send(JSON.stringify({
		    action: 'addToDoItem',
	        title: titleToAdd
        }));
    }
};
